; tabstop=8
;
; SD6031pt@CZN^ ver2.0
;
; Np
;

	ORG	0F700H

	CALL	KISHU
	LD	A,L
	CP	02H
	JR	C,ML_L0

	LD	A,"2"
	LD	(MAXDRIVE),A
ML_L0:

	LD	A,L
	OR	A
	JR	NZ,ML_CH_MK2

		;
		; @ROM̗L`FbN
		;

	LD	HL,(7003H)
	LD	D,"D"
	LD	E,"S"
	OR	A
	SBC	HL,DE
	JR	NZ,ML_CH_END

	LD	A,01H
	LD	(MEMCHECK),A

	JR	ML_CH_END

ML_CH_MK2:
		;
		; mk2ȍ~̊ORAM̗L`FbN
		;

	DI

	IN	A,(0F1H)
	PUSH	AF
	IN	A,(0F2H)
	PUSH	AF
	LD	A,0DEH
	OUT	(0F1H),A
	LD	A,065H
	OUT	(0F2H),A

	LD	HL,55AAH
	LD	(0BFFEH),HL
	EX	DE,HL
	LD	HL,(0BFFEH)

	POP	AF
	OUT	(0F2H),A
	POP	AF
	OUT	(0F1H),A

	EI

	OR	A
	SBC	HL,DE
	JR	NZ,ML_CH_END

	LD	A,02H
	LD	(MEMCHECK),A

	PUSH	HL

ML_CH_END:
	POP	HL		; CALLLZ
	LD	HL,S_KIDOU1
	CALL	30CFH		; \

	LD	A,(MEMCHECK)
	OR	A
	JR	Z,ML_NOMEM

	LD	HL,S_KIDOU2
	CALL	30CFH		; \

	LD	A,(MEMCHECK)
	DEC	A
	LD	HL,S_KIDOUP6
	JR	Z,ML_L1
	LD	HL,S_KIDOUMK2
ML_L1:	CALL	30CFH		; \

	LD	HL,S_KIDOU3
	CALL	30CFH		; \

ML_NOMEM:
	LD	HL,S_HIT
	CALL	30CFH		; \

ML_L2:	LD	HL,S_DRIVE1
	CALL	30CFH		; \

	LD	A,(MAXDRIVE)
	CALL	1075H		; P\

	LD	HL,S_DRIVE2
	CALL	30CFH		; \

	LD	A,(DRIVENUM)
	CALL	1075H		; P\
	LD	A,0DH
	CALL	1075H		; P\

ML_LL:	CALL	0FBCH		; A^CL[
	JR	Z,ML_LL

	CP	0DH
	JR	Z,ML_LEND

	CP	"1"
	JR	C,ML_LL

	LD	B,A
	LD	A,(MAXDRIVE)
	CP	B
	JR	C,ML_LL

	LD	A,B

	LD	(DRIVENUM),A
	JR	ML_L2

ML_LEND:
	LD	A,(DRIVENUM)
	SUB	"0"
	LD	(0FB3BH),A

	RET


;
; @픻
;
; RETURN
; Lreg @Fbit2=mk2SR,66SR / bit1=66,66SR / bit0=mk2,mk2SR,66,66SR
;

KISHU:	DI
	LD	L,00H
		;
		; @ƂȊO|[g0xF6gĔ
		;
	LD	C,0F6H
	IN	B,(C)		; |[g0xF6 ̒lۑ
	LD	DE,55AAH
	OUT	(C),D		; |[g0xF6 0x55o͂ăeXg
	IN	A,(C)
	CP	D		; ǂݏoĊmF
	JR	NZ,P6
	OUT	(C),E		; |[g0xF6 0xAAo͂ăeXg
	IN	A,(C)
	CP	E		; ǂݏoĊmF
	JR	NZ,P6

	OUT	(C),B		; |[g0xF6 ̒l߂
	JR	NEXT1

P6:	EI			; PC-6001
	RET

NEXT1:
	INC	L
		;
		; mk266Amk2SR66SRfBXNpFIFOgĔ
		;
	LD	A,0F3H
	OUT	(0B1H),A	; fBXNɐݒ
	LD	BC,00D0H
	LD	DE,55AAH
	OUT	(C),D		; fBXNpFIFOAhX0x000x55
	INC	B
	OUT	(C),E		; fBXNpFIFOAhX0x010xAA
	IN	A,(C)
	CP	E		; AhX0x01̒lǂݏoĊmF
	JR	NZ,NoDisk
	DEC	B
	IN	A,(C)
	CP	D		; AhX0x00̒lǂݏoĊmF
	JR	NZ,NoDisk

	INC	L		; PC-6601/PC-6601SR
	INC	L

NoDisk:
		;
		; SR|[g0xA3gĔ
		;
	IN	A,(0A3H)	; |[g0xA3ǂݏo
	CPL			; ]i|[gȂȂ0x00)
	LD	D,A
	IN	A,(0A3H)	; |[g0xA3ǂݏo
	CPL			; ]i|[gȂȂ0x00)
	LD	E,A
	IN	A,(0A3H)	; |[g0xA3ǂݏo
	CPL			; ]i|[gȂȂ0x00)
	LD	B,A
	IN	A,(0A3H)	; |[g0xA3ǂݏo
	CPL			; ]i|[gȂȂ0x00)
	OR	B
	OR	D
	OR	E
	JR	Z,NoSR

	INC	L		; PC-6001mk2SR/PC-6601SR
	INC	L
	INC	L
	INC	L

NoSR:

	LD	A,0F7H
	OUT	(0B1H),A	; hCuOt

	EI
	RET

DRIVENUM:
	DB	"1"		; hCu

MAXDRIVE:
	DB	"4"		; őhCu

MEMCHECK:
	DB	0		; 풓\`FbN

S_KIDOU1:
	DB	00CH,"BASIC"
	DB	086H,097H,0E4H,0DEH,093H	; ǂ
	DB	09CH,0EFH,09DH,0A1H		; ܂B
	DB	00DH,00AH,00DH,00AH,00DH,00AH,000H

S_KIDOU2:
	DB	"BASIC"
	DB	097H,0E4H,0DEH,093H		; ǂ
	DB	0E9H,0E9H,0E1H,0A4H		; ̂̂A
	DB	"   "
	DB	"EXEC &H",000H

S_KIDOUP6:
	DB	"7000",000H

S_KIDOUMK2:
	DB	"FC00",000H

S_KIDOU3:
	DB	00DH,00AH,00DH,00AH
	DB	0E3H,0DEH			; 
	DB	"Ұ޾ڸ"
	DB	096H,0DEH			; 
	DB	097H,0E4H,0DEH,093H		; ǂ
	DB	09CH,0EFH,09DH,0A1H		; ܂B
	DB	00DH,00AH,00DH,00AH,00DH,00AH,000H

S_DRIVE1:
	DB	09CH,0F6H,093H,09DH,0F9H	; 悤
	DB	"ײ"
	DB	09DH,093H,0EAH			; 
	DB	" (1-",000H
S_DRIVE2:
	DB	") ? ",000H

S_HIT:	DB	00DH,00AH,00DH,00AH
	DB	"HIT RETURN KEY TO START BASIC"
	DB	01EH,01EH,00DH,000H



	ORG	0F8FFH

	DB	0FFH


	END

